# time_use.py
# author: Marko Borazio for ESS, TU Darmstadt
# Nov/Dec 2012
# description:
# helper functions for the time-use study

import itertools
import numpy as np

#----------------------------------------------------------------------#

#find previous activity
def get_prev(uvec, tval):
	vec = [k for k, g in itertools.groupby(uvec[:tval])]
	# if no previous activity is present, 
	# check for prev activity in the evening
	if len(vec) == 0:
		lvec = [k for k, g in itertools.groupby(uvec)]
		if lvec[-1] == uvec[tval]:
			return lvec[-2]
		else:
			return lvec[-1]		
	# only one activity was found
	elif len(vec) == 1:
		# as before: find last previous activity in the evening
		if vec == uvec[tval]:
			lvec = [k for k, g in itertools.groupby(uvec)]
			if lvec[-1] == uvec[tval]:
				return lvec[-2]
			else:
				return lvec[-1]	
		else:
			return vec
	# get previous activity
	else: 
		if vec[-1] != uvec[tval]:
			return vec[-1]
		else:
			return vec[-2]

#----------------------------------------------------------------------#

#create a list of unique activity codes per given dataset (a day of the user)
def get_unique(foo):
	return np.array([k for k, g in itertools.groupby(foo)],int)

#----------------------------------------------------------------------#
